--Vehicle module

vector = require"./Hump/vector"
module("Vehicle", package.seeall)

Bot = {}

--Member Variables
Bot.prototype = {
	position = vector.new(0,0),
	velocity = vector.new(0,0),
	steeringForce = vector.new(0,0),
	acceleration = vector.new(0,0),
	heading = vector.new(0,0),
	side = vector.new(0,0),
	mass = 1,
	maxSpeed = 150,
	maxForce = 1,
	maxTurnRate = 3.14,
	seekOn = false,
	fleeOn = false,
	arriveOn = false,
	pursuitOn = false
	}

Bot.mt = {}

function Bot:New(object)
	return setmetatable(object, Bot.mt)
end

Bot.mt.__index =  Bot.prototype

--Set SteeringBehaviour
function Bot.prototype:SetSeek(bool)
	self.seekOn = bool
end

function Bot.prototype:SetFlee(bool)
	self.fleeOn = bool
end

function Bot.prototype:SetArrive(bool)
	self.arriveOn = bool
end

function Bot.prototype:SetPursuit(bool)
	self.pursuitOn = bool
end

--Set local coordinate system, heading is x axis, side is y
--visually it is a cross section of the bot, the  bot is a triangle
function Bot.prototype:SetHeadingAndSide()
	if self.velocity:len() > 0.00001 then
		self.heading = self.velocity:normalized()
		self.side = self.heading:perpendicular()
	end
end

--Wrap the bots position so they dont' go off screen
function Bot.prototype:WrapPosition()
	if self.position.x < 0 then
		self.position.x = 799
	end

	if self.position.x > 800 then
		self.position.x = 1
	end

	if self.position.y < 0 then
		self.position.y = 599
	end

	if self.position.y > 600 then
		self.position.y = 1
	end
end

--Use this to init values
function Bot.prototype:Init(position, mass, maxSpeed, maxTurnRate)
	self.position = position
	self.mass = mass
	self.maxSpeed = maxSpeed
	self.maxTurnRate = maxTurnRate
end

--Used to update the bots position
function Bot.prototype:Update(dt, SteeringBehaviour, evader, target)
	self.steeringForce = SteeringBehaviour:CalculateSteeringForce(self, evader, target)
	self.acceleration = self.steeringForce / self.mass
	self.velocity = self.velocity + self.acceleration * dt
	self.position = self.position + self.velocity * dt

	self:SetHeadingAndSide()
	self:WrapPosition()
end










